umbrello: UMLStereotype Class Reference

umbrello 2.39.3 Umbrello UML Modeller is a Unified Modelling Language (UML) diagram program based on KDE Technology

- Main Page
- Related Pages
- Topics
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Protected Attributes | List of all members
UMLStereotype Class Reference

Sets up stereotype information. More...

`#include <stereotype.h>`

Inheritance diagram for UMLStereotype:

## Classes
class | AttributeDef

## Public Types
typedef QVector< AttributeDef > | AttributeDefs
| size is at most N_STEREOATTRS
Public Types inherited from UMLObject
enum | ObjectType { ot_Unknown = -1 , ot_UMLObject = 100 , ot_Actor , ot_UseCase , ot_Package , ot_Interface , ot_Datatype , ot_Enum , ot_Class , ot_Instance , ot_Association , ot_Attribute , ot_Operation , ot_EnumLiteral , ot_Template , ot_Component , ot_Artifact , ot_Node , ot_Stereotype , ot_Role , ot_Entity , ot_EntityAttribute , ot_Folder , ot_EntityConstraint , ot_UniqueConstraint , ot_ForeignKeyConstraint , ot_CheckConstraint , ot_Category , ot_Port , ot_InstanceAttribute , ot_SubSystem }

## Public Member Functions
| UMLStereotype (const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLStereotype ()
virtual | ~UMLStereotype ()
bool | operator== (const UMLStereotype &rhs) const
virtual void | copyInto (UMLObject *lhs) const
virtual UMLObject * | clone () const
void | incrRefCount ()
void | decrRefCount ()
int | refCount () const
QString | name (bool includeAdornments=false) const
void | clearAttributeDefs ()
void | setAttributeDefs (const AttributeDefs &adefs)
const AttributeDefs & | getAttributeDefs () const
AttributeDefs & | getAttributeDefs ()
void | saveToXMI (QXmlStreamWriter &writer)
bool | load1 (QDomElement &element)
virtual bool | showPropertiesDialog (QWidget *parent)
Public Member Functions inherited from UMLObject
| UMLObject (const UMLObject &other)
| UMLObject (UMLObject *parent, const QString &name, Uml::ID::Type id=Uml::ID::None)
| UMLObject (UMLObject *parent)
| UMLObject (const QString &name=QString(), Uml::ID::Type id=Uml::ID::None)
virtual | ~UMLObject ()
bool | operator== (const UMLObject &rhs) const
virtual void | setBaseType (ObjectType ot)
ObjectType | baseType () const
QLatin1String | baseTypeStr () const
virtual void | setID (Uml::ID::Type NewID)
virtual Uml::ID::Type | id () const
QString | doc () const
bool | hasDoc () const
void | setDoc (const QString &d)
void | setVisibility (Uml::Visibility::Enum visibility)
void | setVisibilityCmd (Uml::Visibility::Enum visibility)
Uml::Visibility::Enum | visibility () const
void | setStereotype (const QString &_name)
void | setStereotypeCmd (const QString &_name)
QString | stereotype (bool includeAdornments=false) const
void | setUMLStereotype (UMLStereotype *stereo)
UMLStereotype * | umlStereotype () const
QStringList & | tags ()
QString | package (const QString &separator=QString(), bool includeRoot=false) const
UMLPackageList | packages (bool includeRoot=false) const
bool | setUMLPackage (UMLPackage *pPkg)
UMLPackage * | umlPackage () const
void | setUMLParent (UMLObject *parent)
UMLObject * | umlParent () const
virtual void | setName (const QString &strName)
virtual void | setNameCmd (const QString &strName)
QString | name () const
virtual QString | fullyQualifiedName (const QString &separator=QString(), bool includeRoot=false) const
void | setAbstract (bool bAbstract)
bool | isAbstract () const
virtual bool | resolveRef ()
virtual bool | loadFromXMI (QDomElement &element)
bool | loadStereotype (QDomElement &element)
void | setStatic (bool bStatic)
bool | isStatic () const
virtual bool | acceptAssociationType (Uml::AssociationType::Enum) const
void | setSecondaryId (const QString &id)
QString | secondaryId () const
void | setSecondaryFallback (const QString &id)
QString | secondaryFallback () const
void | save1 (QXmlStreamWriter &writer, const QString &type, const QString &tag=QString())
bool | isUMLActor () const
bool | isUMLArtifact () const
bool | isUMLAssociation () const
bool | isUMLAttribute () const
bool | isUMLCategory () const
bool | isUMLCheckConstraint () const
bool | isUMLClassifier () const
bool | isUMLComponent () const
bool | isUMLDatatype () const
bool | isUMLEntity () const
bool | isUMLEntityAttribute () const
bool | isUMLEntityConstraint () const
bool | isUMLEnum () const
bool | isUMLEnumLiteral () const
bool | isUMLFolder () const
bool | isUMLForeignKeyConstraint () const
bool | isUMLInstance () const
bool | isUMLInstanceAttribute () const
bool | isUMLNode () const
bool | isUMLObject () const
bool | isUMLOperation () const
bool | isUMLPackage () const
bool | isUMLPort () const
bool | isUMLRole () const
bool | isUMLStereotype () const
bool | isUMLTemplate () const
bool | isUMLUniqueConstraint () const
bool | isUMLUseCase () const
UMLActor * | asUMLActor ()
UMLArtifact * | asUMLArtifact ()
UMLAssociation * | asUMLAssociation ()
UMLAttribute * | asUMLAttribute ()
UMLCanvasObject * | asUMLCanvasObject ()
UMLCategory * | asUMLCategory ()
UMLCheckConstraint * | asUMLCheckConstraint ()
UMLClassifier * | asUMLClassifier ()
UMLClassifierListItem * | asUMLClassifierListItem ()
UMLClassifierSet * | asUMLClassifierSet ()
UMLComponent * | asUMLComponent ()
UMLDatatype * | asUMLDatatype ()
UMLEntity * | asUMLEntity ()
UMLEntityAttribute * | asUMLEntityAttribute ()
UMLEntityConstraint * | asUMLEntityConstraint ()
UMLEnum * | asUMLEnum ()
UMLEnumLiteral * | asUMLEnumLiteral ()
UMLFolder * | asUMLFolder ()
UMLForeignKeyConstraint * | asUMLForeignKeyConstraint ()
UMLInstance * | asUMLInstance ()
UMLInstanceAttribute * | asUMLInstanceAttribute ()
UMLNode * | asUMLNode ()
UMLObject * | asUMLObject ()
UMLOperation * | asUMLOperation ()
UMLPackage * | asUMLPackage ()
UMLPort * | asUMLPort ()
UMLRole * | asUMLRole ()
UMLStereotype * | asUMLStereotype ()
UMLTemplate * | asUMLTemplate ()
UMLUniqueConstraint * | asUMLUniqueConstraint ()
UMLUseCase * | asUMLUseCase ()
const UMLActor * | asUMLActor () const
const UMLArtifact * | asUMLArtifact () const
const UMLAssociation * | asUMLAssociation () const
const UMLAttribute * | asUMLAttribute () const
const UMLCanvasObject * | asUMLCanvasObject () const
const UMLCategory * | asUMLCategory () const
const UMLCheckConstraint * | asUMLCheckConstraint () const
const UMLClassifier * | asUMLClassifier () const
const UMLClassifierListItem * | asUMLClassifierListItem () const
const UMLClassifierSet * | asUMLClassifierSet () const
const UMLComponent * | asUMLComponent () const
const UMLDatatype * | asUMLDatatype () const
const UMLEntity * | asUMLEntity () const
const UMLEntityAttribute * | asUMLEntityAttribute () const
const UMLEntityConstraint * | asUMLEntityConstraint () const
const UMLEnum * | asUMLEnum () const
const UMLEnumLiteral * | asUMLEnumLiteral () const
const UMLFolder * | asUMLFolder () const
const UMLForeignKeyConstraint * | asUMLForeignKeyConstraint () const
const UMLInstance * | asUMLInstance () const
const UMLInstanceAttribute * | asUMLInstanceAttribute () const
const UMLNode * | asUMLNode () const
const UMLObject * | asUMLObject () const
const UMLOperation * | asUMLOperation () const
const UMLPackage * | asUMLPackage () const
const UMLPort * | asUMLPort () const
const UMLRole * | asUMLRole () const
const UMLStereotype * | asUMLStereotype () const
const UMLTemplate * | asUMLTemplate () const
const UMLUniqueConstraint * | asUMLUniqueConstraint () const
const UMLUseCase * | asUMLUseCase () const

## Protected Attributes
int | m_refCount
AttributeDefs | m_attrDefs
Protected Attributes inherited from UMLObject
Uml::ID::Type | m_nId
| object's id
QString | m_Doc
| object's documentation
QPointer< UMLStereotype > | m_pStereotype
| stereotype of the object if applicable
QString | m_name
| objects name
ObjectType | m_BaseType
| objects type
Uml::Visibility::Enum | m_visibility
| objects visibility
bool | m_bAbstract
| state of whether the object is abstract or not
bool | m_bStatic
| flag for instance scope
bool | m_bCreationWasSignalled
| auxiliary to maybeSignalObjectCreated()
QPointer< UMLObject > | m_pSecondary
QString | m_SecondaryId
QString | m_SecondaryFallback
QStringList | m_TaggedValues
UMLObjectPrivate * | m_d
| private data

## Additional Inherited Members
Public Slots inherited from UMLObject
void | emitModified ()
Signals inherited from UMLObject
void | modified ()
Static Public Member Functions inherited from UMLObject
static QString | toString (ObjectType ot)
static QString | toI18nString (ObjectType t)
static Icon_Utils::IconType | toIcon (ObjectType t)
Protected Member Functions inherited from UMLObject
void | init ()
void | maybeSignalObjectCreated ()
void | save1end (QXmlStreamWriter &writer)

## Detailed Description

Sets up stereotype information.

This class is used to set up information for a stereotype. Stereotypes are used essentially as properties of attributes and operations etc.

Each stereotype object is reference counted, i.e. client code manages it such that it comes into existence as soon as there is at least one user, and ceases existing when the number of users drops to 0. m_refCount reflects the number of users. It is externally managed, i.e. client code must take care to call incrRefCount() and decrRefCount() as appropriate.

The one and only owner of all stereotypes is the UMLDoc, and the ownership is specially managed (umlPackage() returns NULL for a UMLStereotype.) The reason for this special treatment is that class UMLDoc does not inherit from class UMLPackage, and therefore setUMLPackage() cannot be used for stereotypes.

Author
  Jonathan Riddell
  Oliver Kellogg Bugs and comments to umbre.nosp@m.llo-.nosp@m.devel.nosp@m.@kde.nosp@m..org or https://bugs.kde.org

## Member Typedef Documentation

## ◆ AttributeDefs

QVector<AttributeDef> UMLStereotype::AttributeDefs

size is at most N_STEREOATTRS

## Constructor & Destructor Documentation

## ◆ UMLStereotype() [1/2]

UMLStereotype::UMLStereotype | ( | const QString & | name,
|  | Uml::ID::Type | id = Uml::ID::None )
| explicit

Sets up a stereotype.

Parameters

  name | The name of this UMLStereotype.
  id | The unique id given to this UMLStereotype.

## ◆ UMLStereotype() [2/2]

UMLStereotype::UMLStereotype | ( |  | ) |

Sets up a stereotype.

## ◆ ~UMLStereotype()

UMLStereotype::~UMLStereotype | ( |  | ) |
| virtual

Destructor.

## Member Function Documentation

## ◆ clearAttributeDefs()

void UMLStereotype::clearAttributeDefs | ( |  | ) |

Reset stereotype attribute definitions to none.

## ◆ clone()

UMLObject * UMLStereotype::clone | ( |  | ) | const
| virtual

Make a clone of this object.

Reimplemented from UMLObject.

## ◆ copyInto()

void UMLStereotype::copyInto | ( | UMLObject * | lhs | ) | const
| virtual

Copy the internal presentation of this object into the new object.

Reimplemented from UMLObject.

## ◆ decrRefCount()

void UMLStereotype::decrRefCount | ( |  | ) |

Decrements the reference count for this stereotype.

## ◆ getAttributeDefs() [1/2]

UMLStereotype::AttributeDefs & UMLStereotype::getAttributeDefs | ( |  | ) |

Getter for stereotype attribute definitions returning writable data.

## ◆ getAttributeDefs() [2/2]

const UMLStereotype::AttributeDefs & UMLStereotype::getAttributeDefs | ( |  | ) | const

Const getter for stereotype attribute definitions.

## ◆ incrRefCount()

void UMLStereotype::incrRefCount | ( |  | ) |

Increments the reference count for this stereotype.

## ◆ load1()

bool UMLStereotype::load1 | ( | QDomElement & | element | ) |
| virtual

Auxiliary to loadFromXMI: The loading of stereotype attributes is implemented here.

Reimplemented from UMLObject.

## ◆ name()

QString UMLStereotype::name | ( | bool | includeAdornments = false | ) | const

Returns the name as string

## ◆ operator==()

bool UMLStereotype::operator== | ( | const UMLStereotype & | rhs | ) | const

Overloaded '==' operator.

## ◆ refCount()

int UMLStereotype::refCount | ( |  | ) | const

Returns the reference count for this stereotype.

## ◆ saveToXMI()

void UMLStereotype::saveToXMI | ( | QXmlStreamWriter & | writer | ) |
| virtual

Saves to the <UML:StereoType> XMI element.

Reimplemented from UMLObject.

## ◆ setAttributeDefs()

void UMLStereotype::setAttributeDefs | ( | const AttributeDefs & | adefs | ) |

Setter for stereotype attribute definitions.

## ◆ showPropertiesDialog()

bool UMLStereotype::showPropertiesDialog | ( | QWidget * | parent | ) |
| virtual

Display the properties configuration dialog for the stereotype (just a line edit).

Reimplemented from UMLObject.

## Member Data Documentation

## ◆ m_attrDefs

AttributeDefs UMLStereotype::m_attrDefs
| protected

## ◆ m_refCount

int UMLStereotype::m_refCount
| protected

The documentation for this class was generated from the following files:

- umbrello/umlmodel/stereotype.h
- umbrello/umlmodel/stereotype.cpp